local L = AceLibrary("AceLocale-2.2"):new("Tradebar");
TradeBar = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0");
TradeBar:RegisterDB("TradeBarData");

function Debug(Value)
--  DEFAULT_CHAT_FRAME:AddMessage(Value)
end

local options = {
  type = 'group',
  args = { 
    locked = {
      type = 'toggle',
      name = "Locked",
      desc = L["Lock the frame to the actual position"],
      get  = "GetLocked",
      set  = "SetLocked",
    },
    scale = {
      type = "range",
      name = "Scale",
      desc = L["Scale the buttons"],
      min = 0,
      max = 2,
      isPercent = true,
      get = "GetScale",
      set = "SetScale",
    },
    visible = {
      type = 'toggle',
      name = "Visible",
      desc = L["Show the tradebar"],
      get = "GetVisible",
      set = "SetVisible",
    },
    padding = {
      type = 'range',
      name = "Padding",
      desc = L["adjust the padding between buttons"],
      min  = 0,
      max  = 100,
      get  = "GetPadding",
      set  = "SetPadding",
    },
    direction = {
      type = 'toggle',
      name = "Direction",
      desc = L["On means vertical, Off means horizontal"],
      get  = "GetDirection",
      set  = "SetDirection",
    },
    button = {
      type = 'group',
      name = "Button",
      desc = L["Show wich buttons?"],
      args = {
        al = {
          type = 'toggle',
          name = "Alchemy",
          desc = L["Alchemy"],
          get = "GetAlchemy",
          set = "SetAlchemy",
        },  --alchemy
        fa = {
          type = 'toggle',
          name = "First Aid",
          desc = L["First Aid"],
          get = "GetFirstAid",
          set = "SetFirstAid",
        },  --firstaid
        jc = {
          type = 'toggle',
          name = "Jewelcrafting",
          desc = L["Jewelcrafting"],
          get  = "GetJewelcrafting",
          set  = "SetJewelcrafting",
        },
        eg = {
          type = 'toggle',
          name = "Engineering",
          desc = L["Engineering"],
          get  = "GetEngineering",
          set  = "SetEngineering",
        },
        lw = {
          type = 'toggle',
          name = "Leatherworking",
          desc = L["Leatherworking"],
          get  = "GetLeatherworking",
          set  = "SetLeatherworking",
        },
        fm = {
          type = 'toggle',
          name = "Find Minerals",
          desc = L["Find Minerals"],
          get  = "GetFindMinerals",
          set  = "SetFindMinerals",
        },
        sd = {
          type = 'toggle',
          name = "Sense Demons",
          desc = L["Sense Demons"],
          get  = "GetSenseDemons",
          set  = "SetSenseDemons",
        },
        bs = {
          type = 'toggle',
          name = "Blacksmithing",
          desc = L["Blacksmithing"],
          get  = "GetBlackSmithing",
          set  = "SetBlackSmithing",
        },
        ck = {
          type = 'toggle',
          name = "Cooking",
          desc = L["Cooking"],
          get  = "GetCooking",
          set  = "SetCooking",
        },
        bc = {
          type = 'toggle',
          name = "Basic Campfire",
          desc = L["Basic Campfire"],
          get  = "GetBasicCampfire",
          set  = "SetBasicCampfire",
        },
        ec = {
          type = 'toggle',
          name = "Enchanting",
          desc = L["Enchanting"],
          get  = "GetEnchanting",
          set  = "SetEnchanting",
        },
        dc = {
          type = 'toggle',
          name = "Disenchant",
          desc = L["Disenchant"],
          get  = "GetDisenchant",
          set  = "SetDisenchant",
        },
        fs = {
          type = 'toggle',
          name = "Fishing",
          desc = L["Fishing"],
          get  = "GetFishing",
          set  = "SetFishing",
        },
        hb = {
          type = 'toggle',
          name = "Herbalism",
          desc = L["Herbalism"],
          get  = "GetHerbalism",
          set  = "SetHerbalism",
        },
        fh = {
          type = 'toggle',
          name = "Find Herbs",
          desc = L["Find Herbs"],
          get  = "GetFindHerbs",
          set  = "SetFindHerbs",
        },
        ft = {
          type = 'toggle',
          name = "Find Treasure",
          desc = L["Find Treasure"],
          get  = "GetFindTreasure",
          set  = "SetFindTreasure",
        },
        pl = {
          type = 'toggle',
          name = "Pick Lock",
          desc = L["Pick Lock"],
          get  = "GetPickLock",
          set  = "SetPickLock",
        },
        pp = {
          type = 'toggle',
          name = "Pick Pocket",
          desc = L["Pick Pocket"],
          get  = "GetPickPocket",
          set  = "SetPickPocket",
        },
        sm = {
          type = 'toggle',
          name = "Smelting",
          desc = L["Smelting"],
          get  = "GetSmelting",
          set  = "SetSmelting",
        },
        sk = {
          type = 'toggle',
          name = "Skinning",
          desc = L["Skinning"],
          get  = "GetSkinning",
          set  = "SetSkinning",
        },
        tl = {
          type = 'toggle',
          name = "Tailoring",
          desc = L["Tailoring"],
          get  = "GetTailoring",
          set  = "SetTailoring",
        },
        ps = {
          type = 'toggle',
          name = "Poisons",
          desc = L["Poisons"],
          get  = "GetPoisons",
          set  = "SetPoisons",
        },
        so = {
          type = 'toggle',
          name = "Probe",
          desc = L["Sondieren"],
          get  = "GetSondieren",
          set  = "SetSondieren",
        },
      },    --args
    },      --show
  },        --args
}           --options

TradeBar:RegisterChatCommand( { "/tradebar", "/tb" }, options)

  TradeBarData = { };
    TRADES_ALCHEMY = L["Alchemy"];
    TRADES_MASTER_TRANSMUTATION = L["Master of Transmutation"];
    TRADES_MASTER_ELIXIR = L["Master of Elixirs"];
    TRADES_MASTER_POTIONS = L["Master of Potions"];    
    TRADES_BLACKSMITHING = L["Blacksmithing"];
    TRADES_COOKING = L["Cooking"];
    TRADES_BASIC_CAMPFIRE = L["Basic Campfire"];
    TRADES_ENCHANTING = L["Enchanting"];
    TRADES_DISENCHANT = L["Disenchant"];
    TRADES_ENGINEERING = L["Engineering"];
    TRADES_GNOME_ENGINEERING = L["Gnome Engineering"];
    TRADES_GOBLIN_ENGINEERING = L["Goblin Engineering"];
    TRADES_FIRST_AID = L["First Aid"];
    TRADES_FISHING = L["Fishing"];
    TRADES_HERBALISM = L["Herbalism"];
    TRADES_FIND_HERBS = L["Find Herbs"];
    TRADES_FIND_TREASURE = L["Find Treasure"];
    TRADES_LEATHERWORKING = L["Leatherworking"];
    TRADES_DRAGONSCALE_LEATHERWORKING = L["Dragonscale Leatherworking"];
    TRADES_ELEMENTAL_LEATHERWORKING = L["Elemental Leatherworking"];
    TRADES_TRIBAL_LEATHERWORKING = L["Tribal Leatherworking"]; 
    TRADES_PICK_LOCK = L["Pick Lock"]; 
    TRADES_PICK_POCKET = L["Pick Pocket"];
    TRADES_FIND_MINERALS = L["Find Minerals"];
    TRADES_SMELTING = L["Smelting"];
    TRADES_SKINNING = L["Skinning"];
    TRADES_TAILORING = L["Tailoring"];
    TRADES_SHADOWEAVE_TAILORING = L["Shadoweave Tailoring"];
    TRADES_MOONCLOTH_TAILORING = L["Mooncloth Tailoring"];
    TRADES_SPELLFIRE_TAILORING = L["Spellfire Tailoring"];
    TRADES_POISONS = L["Poisons"];
    TRADES_JEWELCRAFTING = L["Jewelcrafting"];
    TRADES_SONDIEREN = L["Sondieren"];
    TRADES_SENSE_DEMONS = L["Sense Demons"];
    
local Trades = {
  TRADES_ALCHEMY,
  TRADES_MASTER_TRANSMUTATION,
  TRADES_MASTER_ELIXIR,
  TRADES_MASTER_POTIONS,    
  TRADES_BLACKSMITHING,
  TRADES_COOKING,
  TRADES_BASIC_CAMPFIRE,
  TRADES_ENCHANTING,
  TRADES_ENGINEERING,
  TRADES_GNOME_ENGINEERING,
  TRADES_GOBLIN_ENGINEERING,
  TRADES_HERBALISM,
  TRADES_FIRST_AID,
  TRADES_FISHING,
  TRADES_JEWELCRAFTING,
  TRADES_LEATHERWORKING,
  TRADES_DRAGONSCALE_LEATHERWORKING,
  TRADES_ELEMENTAL_LEATHERWORKING,
  TRADES_TRIBAL_LEATHERWORKING,
  TRADES_PICK_LOCK,
  TRADES_PICK_POCKET,
  TRADES_SMELTING,
  TRADES_SKINNING,
  TRADES_TAILORING,
  TRADES_SHADOWEAVE_TAILORING,
  TRADES_MOONCLOTH_TAILORING,
  TRADES_SPELLFIRE_TAILORING,
  TRADES_POISONS,
  TRADES_DISENCHANT,
  TRADES_SONDIEREN,
  TRADES_FIND_HERBS,
  TRADES_FIND_TREASURE,
  TRADES_FIND_MINERALS,
  TRADES_SENSE_DEMONS,
  };

local ver = 001;

TRADESBAR_ENABLED = true;

TradeBar:RegisterDefaults("profile", {
    Alchemy = true,
    FirstAid = true,
    Cooking = true,
    Sondieren = true,
    BasicCampfire = true,
    Jewelcrafting = true,
    Engineering = true,
    Blacksmithing = true,
    Enchanting = true,
    Disenchant = true,
    Locked = true,
    Padding = 2,
    Fishing = true,
    Herbalism = true,
    FindHerbs = true,
    FindTreasure = true,
    Leatherworking = true,
    PickLock = true,
    PickPocket = true,
    FindMinerals = true,
    Smelting = true,
    Skinning = true,
    Tailoring = true,
    Poisons = true,
    SenseDemons = true,
    PosLeft = 300,
    PosTop = 800,
    Scale = 1,
    Direction = true,
    Visible = true,
} )

function TradeBar:OnEnable()
  self:RegisterEvent("SPELLS_CHANGED");
  self:RegisterEvent("PLAYER_AURAS_CHANGED");
  self:RegisterEvent("SPELL_UPDATE_COOLDOWN");

  if (self.db.profile.Visible) then
    GUITradeBar:Show();
  end
  TradeBar:ScaleButtons();
  TradeBar:UpdateDirection();
  TradeBar:Update();
end

function TradeBar:ScaleButtons()
  for i = 1, 10 do
    button = getglobal("TradeBarButton"..i);
    if (button.id) then
      Debug("Scale button "..button.id.." to "..self.db.profile.Scale);
      button:SetScale(self.db.profile.Scale)
    end
  end
end

function TradeBar:SPELL_UPDATE_COOLDOWN()
  for i = 1, 10 do
    button = getglobal("TradeBarButton"..i);
    if (button.id) then
      local cooldown = getglobal(button:GetName().."Cooldown");
      local start, duration, enable = GetSpellCooldown(button.id, SpellBookFrame.bookType);
      if (start > 0 and duration > 0) then
        CooldownFrame_SetTimer(cooldown, start, duration, enable);
      end
    end
  end
end

function TradeBar:SPELLS_CHANGED()
  TradeBar:Update();
end

function TradeBar:PLAYER_AURAS_CHANGED()
  TradeBar:Update();
end

function TradeBar:Update()
  Debug("Update the tradebar!")
  local i = 1;
  while (i < 11) do
    getglobal("TradeBarButton"..i):Hide();
    i = i + 1;
  end
  i = 1;
  GUITradeBar:Show();
  for key, value in pairs(Trades) do
    local id = TradeBar:GetSpellID(value);
    if (id) then
      button = getglobal("TradeBarButton"..i);
      button:SetAttribute("type", "spell");
      button:SetAttribute("spell", value);
      local texture = GetSpellTexture(id, BOOKTYPE_SPELL);
      getglobal("TradeBarButton"..i.."Icon"):SetTexture(texture);
      button.id = id;
      button.texture = texture;
      if (TradeBar:ShowButton(value)) then
        i = i + 1;
        button:Show();
      end
    end
  end;
  if (i == 0) then
    GUITradeBar:Hide();
  end
end

function TradeBar:ShowButton(value)
  if (value == TRADES_ALCHEMY or value == TRADES_MASTER_TRANSMUTATION or value == TRADES_MASTER_ELIXIR or value == TRADES_MASTER_POTIONS) then
    return self.db.profile.Alchemy and not self:IsSpellSpecialication(value);
  end
  if (value == TRADES_FIRST_AID) then
    return self.db.profile.FirstAid;
  end
  if (value == TRADES_ENGINEERING or value == TRADES_GNOME_ENGINEERING or value == TRADES_GOBLIN_ENGINEERING) then
    return self.db.profile.Engineering and not self:IsSpellSpecialication(value);
  end
  if (value == TRADES_COOKING) then
    return self.db.profile.Cooking;
  end;
  if (value == TRADES_BASIC_CAMPFIRE) then
    return self.db.profile.BasicCampfire;
  end
  if (value == TRADES_JEWELCRAFTING) then
    return self.db.profile.Jewelcrafting;
  end
  if (value == TRADES_LEATHERWORKING or value == TRADES_TRIBAL_LEATHERWORKING or value == TRADES_DRAGONSCALE_LEATHERWORKING or value == TRADES_ELEMENTAL_LEATHERWORKING) then
    return self.db.profile.Engineering and not self:IsSpellSpecialication(value);
  end
  if (value == TRADES_BLACKSMITHING) then
    return self.db.profile.BlackSmithing;
  end
  if (value == TRADES_COOKING) then
    return self.db.profile.Cooking;
  end
  if (value == TRADES_ENCHANTING) then
    return self.db.profile.Enchanting;
  end
  if (value == TRADES_DISENCHANT) then
    return self.db.profile.Disenchant;
  end
  if (value == TRADES_HERBALISM) then
    return self.db.profile.Herbalism;
  end
  if (value == TRADES_FISHING) then
    return self.db.profile.Fishing;
  end
  if (value == TRADES_PICK_LOCK) then
    return self.db.profile.PickLock;
  end
  if (value == TRADES_PICK_POCKET) then
    return self.db.profile.PickPocket;
  end
  if (value == TRADES_SMELTING) then
    return self.db.profile.Smelting;
  end
  if (value == TRADES_SKINNING) then
    return self.db.profile.Skinning;
  end
  if (value == TRADES_TAILORING or value == TRADES_SHADOWEAVE_TAILORING or value == TRADES_SPELLFIRE_TAILORING or value == TRADES_MOONCLOTH_TAILORING) then
    return self.db.profile.Tailoring and not self:IsSpellSpecialication(value);
  end
  if (value == TRADES_POISONS) then
    return self.db.profile.Poisons;
  end
  if (value == TRADES_FIND_HERBS) then
    return self.db.profile.FindHerbs;
  end
  if (value == TRADES_FIND_TREASURE) then
    return self.db.profile.FindTreasure;
  end
  if (value == TRADES_FIND_MINERALS) then
    return self.db.profile.FindMinerals;
  end
  if (value == TRADES_SENSE_DEMONS) then
    return self.db.profile.SenseDemons;
  end
  if (value == TRADES_SONDIEREN) then
    return self.db.profile.Sondieren;
  end
  return false;
end

function TradeBar:GetSpellID(spell)
  local i = 1;
  local spellID;
  local highestRank;
  while true do
    local spellName = GetSpellName(i, SpellBookFrame.bookType);
    if (not spellName) then
      break;
    end
    if (spellName == spell) then
      Debug("Found |cffffffff'"..spell.." '|r at slot |cffffffff'"..i.."'", 0.1, 1.0, 0.0);
      return i;
    end
    i = i + 1;
    if (i > 2000) then
      break;
    end
  end
  Debug("Could not find |cffffffff'"..spell.."'|r", 2.0, 0.1, 0.0);
  return spellID, highestRank;
end

function TradeBar:IsSpellSpecialication(value)
  if (value == TRADES_ALCHEMY) then
    local id_Trans  = self:GetSpellID(TRADES_MASTER_TRANSMUTATION);
    local id_Elixir = self:GetSpellID(TRADES_MASTER_ELIXIR);
    local id_Pots   = self:GetSpellID(TRADES_MASTER_POTIONS);    
    if (id_Trans or id_Elixir or id_Pots) then
      return true
    end
  elseif (value == TRADES_LEATHERWORKING) then
    local id_Dragon    = self:GetSpellID(TRADES_DRAGONSCALE_LEATHERWORKING);
    local id_Elemental = self:GetSpellID(TRADES_ELEMENTAL_LEATHERWORKING);
    local id_Tribal    = self:GetSpellID(TRADES_TRIBAL_LEATHERWORKING);
    if (id_Dragon or id_Elemental or id_Tribal) then
      return true
    end
  elseif (value == TRADES_ENGINEERING) then
    local id_Gnome  = self:GetSpellID(TRADES_GNOME_ENGINEERING);
    local id_Goblin = self:GetSpellID(TRADES_GOBLIN_ENGINEERING);
    if (id_Gnome or id_Goblin) then
      return true
    end
  elseif (value == TRADES_TAILORING) then
    local id_Shadow = self:GetSpellID(TRADES_SHADOWEAVE_TAILORING);
    local id_Moon = self:GetSpellID(TRADES_MOONCLOTH_TAILORING); 
    local id_Fire = self:GetSpellID(TRADES_SPELLFIRE_TAILORING); 
    if (id_Shadow or id_Moon or id_Fire) then
      return true;
    end
  end
  return false;
end

function TradeBar:UpdateDirection()
  if (self.db.profile.Direction) then
    pnt1 = "LEFT";
    pnt2 = "RIGHT";
    x = self.db.profile.Padding;
    y = 0;
  else
    pnt1 = "TOP";
    pnt2 = "BOTTOM";
    x = 0;
    y = -self.db.profile.Padding;
  end
  
  for i = 2, 10 do
    local button = getglobal("TradeBarButton"..i);
    button:ClearAllPoints();
    button:SetPoint(pnt1, "TradeBarButton"..i-1, pnt2, x, y);
  end
end

function TradeBar:ToggleConfigScreen()
--  if (TradeBarConfig:IsVisible() ) then
--    TradeBarConfig:Hide();
--  else
--    TradeBarConfig:Show();
--  end
end

function TradeBar:StorePosition()
  local vLft = GUITradeBar:GetLeft();
  local vTop = GUITradeBar:GetTop();
  Debug(vLft.." "..vTop);
  self.db.profile.PosLeft = vLft;
  self.db.profile.PosTop  = vTop;
end

function TradeBar:GetAlchemy()
  return self.db.profile.Alchemy
end

function TradeBar:SetAlchemy()
  self.db.profile.Alchemy = not self.db.profile.Alchemy
  self:Update();
end

function TradeBar:GetBlackSmithing()
  return self.db.profile.BlackSmithing
end

function TradeBar:SetBlackSmithing()
  self.db.profile.BlackSmithing = not self.db.profile.BlackSmithing
  self:Update();
end

function TradeBar:GetCooking()
  return self.db.profile.Cooking
end

function TradeBar:SetCooking()
  self.db.profile.Cooking = not self.db.profile.Cooking
  self:Update();
end

function TradeBar:GetEnchanting()
  return self.db.profile.Enchanting
end

function TradeBar:SetEnchanting()
  self.db.profile.Enchanting = not self.db.profile.Enchanting
  self:Update();
end

function TradeBar:GetDisenchant()
  return self.db.profile.Disenchant
end

function TradeBar:SetDisenchant()
  self.db.profile.Disenchant = not self.db.profile.Disenchant
  self:Update();
end

function TradeBar:GetEngineering()
  return self.db.profile.Engineering
end

function TradeBar:SetEngineering()
  self.db.profile.Engineering = not self.db.profile.Engineering
  self:Update();
end

function TradeBar:GetHerbalism()
  return self.db.profile.Herbalism
end

function TradeBar:SetHerbalism()
  self.db.profile.Herbalism = not self.db.profile.Herbalism
  self:Update();
end

function TradeBar:GetFindHerbs()
  return self.db.profile.FindHerbs
end

function TradeBar:SetFindHerbs()
  self.db.profile.FindHerbs = not self.db.profile.FindHerbs
  self:Update();
end

function TradeBar:GetFindTreasure()
  return self.db.profile.FindTreasure
end

function TradeBar:SetFindTreasure()
  self.db.profile.FindTreasure = not self.db.profile.FindTreasure
  self:Update();
end

function TradeBar:GetFishing()
  return self.db.profile.Fishing
end

function TradeBar:SetFishing()
  self.db.profile.Fishing = not self.db.profile.Fishing
  self:Update();
end

function TradeBar:GetLeatherworking()
  return self.db.profile.Leatherworking
end

function TradeBar:SetLeatherworking()
  self.db.profile.Leatherworking = not self.db.profile.Leatherworking
  self:Update();
end

function TradeBar:GetPickLock()
  return self.db.profile.PickLock
end

function TradeBar:SetPickLock()
  self.db.profile.PickLock = not self.db.profile.PickLock
  self:Update();
end

function TradeBar:GetPickPocket()
  return self.db.profile.PickPocket
end

function TradeBar:SetPickPocket()
  self.db.profile.PickPocket = not self.db.profile.PickPocket
  self:Update();
end

function TradeBar:GetFindMinerals()
  return self.db.profile.FindMinerals
end

function TradeBar:SetFindMinerals()
  self.db.profile.FindMinerals = not self.db.profile.FindMinerals
  self:Update();
end

function TradeBar:GetSmelting()
  return self.db.profile.Smelting
end

function TradeBar:SetSmelting()
  self.db.profile.Smelting = not self.db.profile.FindSmelting
  self:Update();
end

function TradeBar:GetSkinning()
  return self.db.profile.Skinning
end

function TradeBar:SetSkinning()
  self.db.profile.Skinning = not self.db.profile.Skinning
  self:Update();
end

function TradeBar:GetTailoring()
  return self.db.profile.Tailoring
end

function TradeBar:SetTailoring()
  self.db.profile.Tailoring = not self.db.profile.Tailoring
  self:Update();
end

function TradeBar:GetPoisons()
  return self.db.profile.Poisons
end

function TradeBar:SetPoisons()
  self.db.profile.Poisons = not self.db.profile.Poisons
  self:Update();
end

function TradeBar:GetSondieren()
  return self.db.profile.Sondieren
end

function TradeBar:SetSondieren()
  self.db.profile.Sondieren = not self.db.profile.Sondieren
  self:Update();
end


function TradeBar:GetDirection()
  return self.db.profile.Direction
end

function TradeBar:SetDirection()
  self.db.profile.Direction = not self.db.profile.Direction
  TradeBar:UpdateDirection();
  self:Update();
end

function TradeBar:GetPadding()
  return self.db.profile.Padding
end

function TradeBar:SetPadding(value)
  if not((self.db.profile.Padding == value)) then
    self.db.profile.Padding = value
    TradeBar:UpdateDirection();
    self:Update();
  end
end

function TradeBar:GetVisible()
  return self.db.profile.Visible
end

function TradeBar:GetLocked()
  return self.db.profile.Locked
end

function TradeBar:SetLocked()
  self.db.profile.Locked = not self.db.profile.Locked;
  GUITradeBar:StopMovingOrSizing();
  TradeBar:StorePosition();
end

function TradeBar:SetVisible()
  self.db.profile.Visible = not self.db.profile.Visible;
  if (self.db.profile.Visible) then
    GUITradeBar:Show();
  else
    GUITradeBar:Hide();
  end
end

function TradeBar:GetFirstAid()
  return self.db.profile.FirstAid
end

function TradeBar:SetFirstAid()
  self.db.profile.FirstAid = not self.db.profile.FirstAid
  self:Update();
end

function TradeBar:GetBasicCampfire()
  return self.db.profile.BasicCampfire
end

function TradeBar:SetBasicCampfire()
  self.db.profile.BasicCampfire = not self.db.profile.BasicCampfire
  self:Update();
end

function TradeBar:GetJewelcrafting()
  return self.db.profile.Jewelcrafting
end

function TradeBar:SetJewelcrafting()
  self.db.profile.Jewelcrafting = not self.db.profile.Jewelcrafting
  self:Update();
end

function TradeBar:GetSenseDemons()
  return self.db.profile.SenseDemons
end

function TradeBar:SetSenseDemons()
  self.db.profile.SenseDemons = not self.db.profile.SenseDemons
  self:Update();
end

function TradeBar:GetScale()
  return self.db.profile.Scale
end

function TradeBar:SetScale(value)
  self.db.profile.Scale = value
  self:ScaleButtons();
end

function TradeBar:GetLeft()
  return self.db.profile.PosLeft
end

function TradeBar:SetLeft(value)
  self.db.profile.PosLeft = value;
--  GUITradeBar:SetLeft(value);
end

function TradeBar:GetTop()
  return self.db.profile.PosTop
end

function TradeBar:SetTop(value)
  self.db.profile.PosTop = value;
--  GUITradeBar:SetTop(value);
end

function TradeBar:CallHandler()
end

